/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reconhecimento;

import java.awt.EventQueue;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Leonel Ceolin Farias
 */
public class Relatorio extends JFrame{
    
    private JPanel contentPane;
    private JTable table;
    DefaultTableModel modelo = new DefaultTableModel();
    
    public static void re(){
        EventQueue.invokeLater(new Runnable(){
            public void run(){
                try {
                    Relatorio frame = new Relatorio();
                    frame.setVisible(true);
                } catch (Exception e){
                        e.printStackTrace();
                }                
            }
        });
    }
    
    public Relatorio() throws IOException{
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100,100,769,467);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5,5,5,5));
        setContentPane(contentPane);
        JScrollPane scrollPane = new JScrollPane();
        
        GroupLayout gl_contentPane = new GroupLayout(contentPane);
        gl_contentPane.setHorizontalGroup(
                gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                .addGap(22)
                .addComponent(scrollPane, GroupLayout.PREFERRED_SIZE,661,GroupLayout.PREFERRED_SIZE)
                .addContainerGap(60, Short.MAX_VALUE))
        );
        gl_contentPane.setVerticalGroup(
                gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                .addGap(162)
                .addComponent(scrollPane, GroupLayout.PREFERRED_SIZE,218,GroupLayout.PREFERRED_SIZE)
                .addContainerGap(39, Short.MAX_VALUE))
        );
        
        table = new JTable(modelo);
        scrollPane.setViewportView(table);
        contentPane.setLayout(gl_contentPane);
        
        modelo.addColumn("Id");
        modelo.addColumn("Nome imagem");
        
        try {
            carregarTabela();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Relatorio.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SQLException ex) {
            Logger.getLogger(Relatorio.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void carregarTabela() throws FileNotFoundException, IOException, SQLException{
        Connection connection = null;
        Statement statement = null;
        ResultSet rs = null;
        InputStream imageStream = null;
        OutputStream out = null;
        try {
            connection = DriverManager.getConnection("jdbc:postgresql://localhost:5432/imagedb", "leonel", "leonel");
            statement = connection.createStatement();
            rs = statement.executeQuery("select * from test");
            while (rs.next()) {
                //get data of first column from result set
                imageStream = rs.getBinaryStream("imagem");
                // initialize output stream with the file to create
                out = new FileOutputStream(new File("src\\decodificado\\" + rs.getString("nomeimagem")));
                modelo.addRow(new Object[]{rs.getInt("id"),rs.getString("nomeimagem")});
                int c = 0;
                //write the contents from the input stream to the output stream
                while ((c = imageStream.read()) > -1) {
			out.write(c);
                }
            }
        } catch (SQLException sqe) {
            throw sqe;
        } finally {
            // close resources
            if (connection != null) {
                connection.close();
            }
            if (imageStream != null) {
                imageStream.close();
            }
            if (out != null) {
                out.close();
            }
            if (statement != null) {
                statement.close();
            }
        }
    }
}
